installation scripts for servers.
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 

106 lines
2.7 KiB

#!/bin/sh
DIR="$(realpath "$(dirname "$0")")"
# script must start at home directory
cd "$HOME" || exit 1;
usertest() {
if test "$(id -u)" -eq 0; then
echo "You cannot run this script as root.";
exit 1;
fi
if ! (getent passwd junikim 2>&1) > /dev/null; then
echo "User junikim must exist.";
exit 1
fi
if ! (apk list | grep 'doas' 2>&1) > /dev/null; then
echo "doas is not installed.";
exit 1
fi
}
dev() {
echo "Developer tools..."
doas apk add git make python3 nodejs npm neovim curl bash
}
sysinfo() {
echo "Dylan Araps scripts"
cd "$HOME" || exit 1;
mkdir -p repos
git clone https://github.com/dylanaraps/pfetch "$HOME/repos/pfetch"
git clone https://github.com/dylanaraps/neofetch "$HOME/repos/neofetch"
git clone https://github.com/dylanaraps/fff "$HOME/repos/fff"
cd "$HOME/repos/pfetch" || exit 1;
doas make install || exit 2;
cd "$HOME" || exit 1;
cd "$HOME/repos/neofetch" || exit 1;
doas make install || exit 2;
cd "$HOME" || exit 1;
cd "$HOME/repos/fff" || exit 1;
doas make install || exit 2;
cd "$HOME" || exit 1;
}
shell() {
echo "zsh installation and configuration as login shell"
doas apk add zsh
# set user permissions
awk -F ':' -v OFS=':' '{
if ($1 == "junikim") {
print $1,$2,$3,$4,$5,$6,"/bin/zsh"
} else {
print $1,$2,$3,$4,$5,$6,$7
}}' /etc/passwd > passwd.tmp
doas mv passwd.tmp /etc/passwd
# add starship and oh my zsh
doas apk add starship
}
# neovim must be installed.
plugins() {
# install vim-plug, oh-my-zsh, and zsh-syntax-highlighting
sh -c 'curl -fLo "${XDG_DATA_HOME:-$HOME/.local/share}"/nvim/site/autoload/plug.vim --create-dirs \
https://raw.githubusercontent.com/junegunn/vim-plug/master/plug.vim'
sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
git clone https://github.com/zsh-users/zsh-syntax-highlighting.git "$HOME/.oh-my-zsh/custom/plugins/zsh-syntax-highlighting"
}
dotfiles() {
echo "Adding vim and zsh configs"
if ! test -d "$DIR/dotfiles"; then
echo "$DIR/dotfiles folder not found.";
exit 1;
fi
mkdir -p "$HOME/.config/nvim"
cp "$DIR/dotfiles/.zshrc" "$HOME/.zshrc"
cp "$DIR/dotfiles/init.vim" "$HOME/.config/nvim/init.vim"
nvim --headless +PlugInstall +qa
}
competitiveprogramming() {
echo "CP Compilers..."
doas apk add g++
doas apk add clang-dev
cd "$HOME" || exit 1;
git clone https://git.junickim.me/junikimm717/linuxcp "$HOME/cp"
}
(usertest && dev && sysinfo && shell && plugins && dotfiles) || exit 1
cat <<EOF
Stuff you should do now:
- run :PlugInstall
- add coc extensions
- add in the competitive programming scripts (if you intend) by running the
competitiveprogramming function
EOF